﻿var Diagram = MindFusion.Diagramming.Diagram;
var CompositeNode = MindFusion.Diagramming.CompositeNode;
var Behavior = MindFusion.Diagramming.Behavior;

var Alignment = MindFusion.Drawing.Alignment;
var Rect = MindFusion.Drawing.Rect;


var OrgChartNode = CompositeNode.classFromTemplate("OrgChartNode",
{
	component: "GridPanel",
	rowDefinitions: ["*"],
	columnDefinitions: ["22", "*"],
	children:
	[
		{
			component: "Rect",
			name: "Background",
			pen: "black",
			brush: "white",
			columnSpan: 2
		},
		{
			component: "Image",
			name: "Image",
			autoProperty: true,
			location: "ceo.png",
			margin: "1",
			imageAlign: "Fit"
		},
		{
			component: "StackPanel",
			orientation: "Vertical",
			gridColumn: 1,
			margin: "1",
			verticalAlignment: "Near",
			children:
			[
				{
					component: "Text",
					name: "Title",
					autoProperty: true,
					text: "title",
					font: "Arial bold"
				},
				{
					component: "Text",
					name: "FullName",
					autoProperty: true,
					text: "full name",
					pen: "blue",
					padding: "1,0,1,0"
				},
				{
					component: "Text",
					name: "Details",
					autoProperty: true,
					text: "details",
					font: "Arial 3"
				}
			]
		}
	]
});

var diagram = null;

window.onload = function ()
{
	// create a Diagram component that wraps the "diagram" canvas
	diagram = Diagram.create(document.getElementById("diagram"));

	// enable drawing of custom nodes interactively
	diagram.setCustomNodeType(OrgChartNode);
	diagram.setBehavior(Behavior.Custom);
};

function drawDiagram()
{
	diagram.clearAll();

//	diagram.invalidate();

	var factory = diagram.getFactory();

	var k = Math.floor(Math.random() * 5) + 1  
	for (var i = 0; i < 10; i++)
	{
		this.createCompositeNode(i, k);
	}
}

function createCompositeNode(i, k)
{
	var node1 = new OrgChartNode(diagram);
	node1.setBounds(new Rect(10*i, 10*k + i*2, 60, 25));
	node1.setTitle(i.toString());
	node1.setImage("ceo.png");
	diagram.addItem(node1);
}

